#! /bin/bash
# 默认变量

# 文件参数变量
# 在执行shell脚本时,可以向脚本传递参数.$1是第一个参数,$2是第二个参数,以此类推.特殊的,$0是文件名(包含路径).例如:

echo "文件名: " $0
echo "第一个参数: " $1
echo "第二个参数: " $2
echo "第三个参数: " $3
echo "第四个参数: " $4


# 其它参数相关变量
# $# 代表文件传入的参数个数,如上例中值为4
echo "参数个数: " $#

# $* 由所有参数构成的用空格隔开的字符串,如上例中值为"$1 $2 $3 $4"
echo "参数构成的空格隔开的字符串: " $*

# $@ 每个参数分别用双引号括起来的字符串,如上例中值为"$1" "$2" "$3" "$4"
echo "参数分别用双引号括起来的字符串: " $@

# $$ 脚本当前运行的进程ID
echo "脚本当前运行的进程ID: " $$

# $? 上一条命令的退出状态(注意不是stdout,而是exit code). 0表示正常退出,其他值表示错误
echo "上一条命令的退出状态: " $?

# $(command) 返回command这条命令的stdout(可嵌套)
echo "命令测试: " $(echo "哈哈")

# 'command' 返回command这条命令的stdout(不可嵌套)
echo "命令测试2: " 'tree'
