#! /bin/bash

# shell 语法 --- 变量


# 定义变量
name1='yxc' # 单引号定义字符串
name2="yxc" # 双引号定义字符串
name3=yxc   # 也可以不加引号,同样表示字符串


# 使用变量
# 需要加上$符号,或者${}符号.花括号是可选的,主要为了帮助解释器识别变量边界
name=yxc
echo $name # 输出yxc
echo ${name} # 输出yxc
echo ${name}acwing # 输出yxcacwing


# 只读变量
# 使用readonly或者declare可以将变量变为只读
name=yxc
readonly name
declare -r name # 两种写法均可

#name=abc #会报错,因为此时name只读


# 删除变量
# unset可以删除变量
name=yxc
unset name
echo $name # 输出空行


# 变量类型
# 1.自定义变量(局部变量)
#   子进程不能访问的变量
# 2.环境变量(全局变量)
#   子进程可以访问的变量

# 自定义变量改成环境变量:
name=yxc # 定义变量
export name # 第一种方法
declare -x 第二种方法

# 环境变量改为自定义变量
export name=yxc # 定义环境变量
declare +x name # 改为自定义变量


# 字符串
# 字符串可以用单引号,也可以用双引号,也可以不用引号
# 单引号与双引号的区别:
#   * 单引号中的内容会原样输出,不会执行、不会取变量
#   * 双引号中的内容可以执行、可以取变量
name=yxc # 不用引号
echo 'hello, $name \"hh\"' # 单引号字符串,输出hello, $name \"hh\"
echo "hello, $name \"hh\"" # 双引号字符串,输出hello, yxc hh


# 获取字符串长度
name="yxc"
echo ${#name} # 输出3


# 提取子串
name="hello, yxc"
echo ${name:0:5} # 提取从0开始的5个字符
